<template>
  <GenericLayout>
    <template #header>
      <Header
        :back-button="true"
        :title="pageTitle"
      />
    </template>

    <template
      #page-content
    >
      <div class="full-height column">
        <template v-if="isDesktopPlatform">
          <div
            class="page-title"
            v-if="pageTitle"
          >
            {{ pageTitle }}
          </div>
          <div
            class="page-subtitle"
            v-if="pageSubTitle"
          >
            {{ pageSubTitle }}
          </div>
        </template>
        <q-card
          :square="!isDesktopPlatform"
          class="column no-wrap col"
        >
          <q-card-section
            class="column no-wrap q-pb-none"
            style="flex-grow: 1"
          >
            <div
              class="text-subtitle1 q-mb-sm"
            >
              <translate>Summary of parameters:</translate>
            </div>
          </q-card-section>

          <q-scroll-area class="full-width full-height q-mt-md">
            <q-expansion-item
              v-for="plot in plots"
              :key="'plot-' + plot.id"
              expand-separator
              expand-icon="las la-angle-down"
              expanded-icon="las la-angle-up"
              class="bg-grey-2"
            >
              <template
                #header
              >
                <q-item-label
                  header
                  class="col-5 q-py-sm"
                >
                  <translate>Plot</translate>
                </q-item-label>
                <q-item-section class="col q-py-sm">
                  {{ plot.name }}
                </q-item-section>
              </template>
              <VisioneComputeSummaryTreeCrop v-if="$store.state.fertilizationPlan.parameters.is_tree_crop" />
              <VisioneComputeSummaryNonTreeCrop
                v-else
                :plot="plot"
              />
            </q-expansion-item>
          </q-scroll-area>

          <!-- buttons -->
          <q-card-section class="q-mt-auto">
            <q-card-actions
              vertical
              align="stretch"
              class="q-pa-none"
            >
              <q-btn
                color="primary"
                text-color="white"
                @click="onClickCompute"
                :loading="computing"
              >
                <translate>Compute</translate>
              </q-btn>
              <q-btn
                flat
                color="primary"
                @click="onClickPrevious"
              >
                <translate>Previous</translate>
              </q-btn>
            </q-card-actions>
          </q-card-section>
        </q-card>
      </div>
    </template>

    <template #footer>
      <Footer />
    </template>
  </GenericLayout>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import GenericLayout from 'src/layouts/GenericLayout'
import Header from 'src/components/layouts/Header'
import Footer from 'src/components/layouts/Footer'
import VisioneComputeSummaryTreeCrop from 'src/pages/fieldbook/fertilization/algorithms/visione/pages/component/VisioneComputeSummaryTreeCrop'
import VisioneComputeSummaryNonTreeCrop from 'src/pages/fieldbook/fertilization/algorithms/visione/pages/component/VisioneComputeSummaryNonTreeCrop'

import AlgorithmsMixins from 'src/pages/fieldbook/fertilization/algorithms/common/mixins/AlgorithmsMixins'
import VisioneMixins from 'src/pages/fieldbook/fertilization/algorithms/visione/mixins/VisioneMixins'

import queryVisioneNPK from 'src/pages/fieldbook/fertilization/algorithms/visione/graphql/queryVisioneNPK'

export default {
  name: 'VisioneComputePage',
  components: {
    GenericLayout,
    Header,
    Footer,
    VisioneComputeSummaryTreeCrop,
    VisioneComputeSummaryNonTreeCrop
  },
  mixins: [PlatformMixin, AlgorithmsMixins, VisioneMixins],
  data () {
    return {
      computing: false
    }
  },
  computed: {
    pageTitle () {
      return this.$gettext('Summary')
    },
    pageSubTitle () {
      return 'Visione'
    },
    plots () {
      return [this.$store.state.fertilizationPlan.target]
    }
  },
  mounted () {
  },
  methods: {
    getSoilObject (plotId) {
      return this.$store.state.fertilizationPlan.parameters.soil_objects.find(so => so.plot.id === plotId)
    },
    async onClickCompute () {
      this.computing = true
      try {
        const inputs = []
        this.plots.forEach(p => {
          const isTreeCrop = this.$store.state.fertilizationPlan.parameters.is_tree_crop
          const input = {
          // TODO rotation per plot
            current_rotations: isTreeCrop
              ? [{
                  crop_yield: null,
                  fertilizations: this.$store.state.fertilizationPlan.parameters?.fertilizations?.length
                    ? this.$store.state.fertilizationPlan.parameters.fertilizations.map(f => {
                      return {
                        dose: parseFloat(f.dose),
                        organic_fertilizer_id: f.organic_fertilizer.id,
                        period_and_method_of_distribution_id: f.organic_fertilizer_efficiency.id,
                        custom_concentration: {
                          n: Number(f.custom_concentration.n),
                          p2o5: Number(f.custom_concentration.p2o5),
                          k2o: Number(f.custom_concentration.k2o)
                        }
                      }
                    })
                    : null,
                  humidity: null,
                  is_green_manure_cover_crop: null,
                  number_of_cycles: null,
                  order_id: 1,
                  production_phase: this.$store.state.fertilizationPlan.parameters.production_phase.id,
                  profile_id: Number(this.$store.state.fertilizationPlan.parameters.visione_profile.id),
                  residues_are_buried: false
                }]
              : this.$store.state.fertilizationPlan.parameters.current_rotations.map((rotation, index) => {
                return {
                  crop_yield: parseFloat(rotation.crop_yield_per_cycle),
                  fertilizations: rotation.fertilizations?.length
                    ? rotation.fertilizations.map(f => {
                      return {
                        dose: parseFloat(f.dose),
                        organic_fertilizer_id: Number(f.organic_fertilizer.id),
                        period_and_method_of_distribution_id: f.organic_fertilizer_efficiency.id,
                        custom_concentration: {
                          n: Number(f.custom_concentration.n),
                          p2o5: Number(f.custom_concentration.p2o5),
                          k2o: Number(f.custom_concentration.k2o)
                        }
                      }
                    })
                    : null,
                  humidity: rotation.crop_yield_humidity_per_cycle != null ? Number(rotation.crop_yield_humidity_per_cycle) : null,
                  is_green_manure_cover_crop: index === 0 ? rotation.is_green_manure_cover_crop : null,
                  number_of_cycles: rotation.crop_cycles,
                  order_id: index + 1,
                  production_phase: null,
                  profile_id: Number(rotation.visione_profile.id),
                  residues_are_buried: rotation.residues_are_buried
                }
              }),
            plot_id: Number(p.id)
          }
          if (!isTreeCrop) {
            const previousRotation = this.$store.state.fertilizationPlan.parameters.previous_rotation
            const soilObject = this.getSoilObject(p.id)
            input.previous_rotation = {
              crop_yield: previousRotation.crop_yield_per_cycle != null ? parseFloat(previousRotation.crop_yield_per_cycle) : null,
              fertilizations: previousRotation.fertilization != null
                ? [{
                    dose: parseFloat(previousRotation.fertilization.dose),
                    organic_fertilizer_id: Number(previousRotation.fertilization.organic_fertilizer.id),
                    custom_concentration: {
                      n: Number(previousRotation.fertilization.custom_concentration.n),
                      p2o5: Number(previousRotation.fertilization.custom_concentration.p2o5),
                      k2o: Number(previousRotation.fertilization.custom_concentration.k2o)
                    }
                  }]
                : null,
              humidity: previousRotation.crop_yield_humidity_per_cycle != null ? Number(previousRotation.crop_yield_humidity_per_cycle) : null,
              number_of_cycles: previousRotation.crop_cycles != null ? Number(previousRotation.crop_cycles) : 1,
              profile_id: Number(previousRotation.visione_profile.id),
              residues_are_buried: previousRotation.residues_are_buried
            }
            input.soil = {
              texture: soilObject.observations.texture.value.id,
              soil_organic_matter: Number(soilObject.observations.organic_matter_pct.value),
              c_n: Number(soilObject.observations.c_n.value),
              p_olsen: Number(soilObject.observations.phosphorus.value),
              k: Number(soilObject.observations.potassium.value),
              ph: Number(soilObject.observations.ph.value),
              is_limy: soilObject.observations.is_limy.value,
              clay: Number(soilObject.observations.clay_pct.value),
              sand: Number(soilObject.observations.sand_pct.value)
            }
            input.strategy = {
              n_target: 0,
              p2o5_target: 0,
              k2o_target: 0,
              manure_distribution: previousRotation.manure_distribution.id
            }
          }
          inputs.push(input)
        })

        const results = await this.$apollo.query({
          query: queryVisioneNPK,
          variables: { inputs },
          fetchPolicy: 'no-cache'
        })
        // Re-group result per plot and keep only the second (current) rotation
        const filteredResults = results.data.visione__npk
          .map(npk => {
            const plot = this.$store.state.fertilizationPlan.target
            if (!plot) {
              throw Error(`Wrong plot_id received from visione: ${npk.plot_id}`)
            }
            return {
              plot,
              ...npk
            }
          })
        this.updateParameter('results', filteredResults)
        this.$router.push({
          name: 'visioneResults'
        })
      } catch (e) {
        console.error('Failed to compute Visione results', e)
        this.$q.notify({
          color: 'red',
          message: this.$gettext('There was an error while computing the plan.')
        })
      } finally {
        this.computing = false
      }
    },
    onClickPrevious () {
      this.$router.back()
    }
  }
}
</script>
